function init()
    tool_name = "lighter"
    RegisterTool(tool_name, "Lighter", "MOD/vox/Lighter.vox")
	SetBool("game.tool." .. tool_name ..".enabled", true)
	SetFloat("game.tool." .. tool_name .. ".ammo", 101)
	firstTry = GetBool("savegame.mod.firsttry")
	
	opening = 0
	enabled = false
	grabing = false
	closing = false
	try_timer = 0
	light = 0
	start_fail_timer = 0
	throw = 60
	throw_cam = 0
	throw_tr = 0
	throw_hit_pos = 0
	
	click_sound = LoadSound("MOD/snd/Click.ogg")
end

function calculateThrow(t, dt)
    local g, Vo = 15, 35
    
    local rx, ry, rz = GetQuatEuler(throw_cam.rot)
	local h = 0
	local tr = TransformCopy(throw_tr)
	local cam = TransformCopy(throw_cam)
	tr.pos = cam.pos
	cam.pos = Vec(0, 0, 0)
	cam.rot = QuatEuler(0, 0, 0)
	local subb = TransformToLocalVec(cam, Vec(0, 0, 0))
	tr.pos = VecAdd(tr.pos, subb)
	local x, y
	x = math.cos(math.rad(rx))*Vo*(t-0.01)
	y = (-0.5)*g*((t-0.01)^2)+(math.sin(math.rad(rx)))*Vo*(t-0.01)+h
	local start = TransformToParentPoint(tr, Vec(0, y, -x))
	x = math.cos(math.rad(rx))*Vo*(t+dt)
	y = (-0.5)*g*((t+0.015)^2)+(math.sin(math.rad(rx)))*Vo*(t+0.015)+h
	local endd = TransformToParentPoint(tr, Vec(0, y, -x))
	local direction = VecSub(endd, start)
	t = t + 0.01
	local hit, d = QueryRaycast(start, VecNormalize(direction), VecLength(direction), 0)
	SetToolTransform(TransformToParentTransform(TransformToLocalTransform(GetPlayerCameraTransform(), Transform(start, GetPlayerCameraTransform().rot)), Transform(Vec(-0.25, 0.25, 0.5), QuatEuler(0, 0, 0))))
	if hit then
	    pos = VecAdd(start, VecScale(VecNormalize(direction), d))
		return pos
	end
	return 0
end

function tick(dt)
    if GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0 then
	    if InputDown("lmb") and grabing then
		    grabing = 1
		else
		    grabing = GetPlayerGrabShape()
		end
		if InputPressed("mmb") and not InputDown("rmb") then
		    if throw == 60 then
			    throw = 0
				throw_cam = GetPlayerCameraTransform()
				throw_tr = GetPlayerTransform()
			elseif throw < 59 then
			    throw = 59
			end
		end
		if throw < 59 then
			local hitpos = calculateThrow(throw, dt)
			throw = throw + dt
			if hitpos ~= 0 then
			    throw = 59
				if not enabled then
				    Explosion(hitpos, 0.5)
					throw_hit_pos = 0
				else
				    throw_hit_pos = hitpos
				    SpawnFire(hitpos)
					MakeHole(hitpos, 0.2, 0.1, 0)
				    for i = 1, 20 do SpawnFire(VecAdd(hitpos, Vec((math.random()-0.5)*2, (math.random()-0.5)*2, (math.random()-0.5)*2))) end
				end
			end
		end
		if throw >= 59 and throw < 60 then
		    PointLight(throw_hit_pos, 1, 0.3, 0.1, 1.25*(1-(throw-59)))
		    SetToolTransform(Transform(Vec(0, 0, 999999), QuatEuler(0, 0, 0)))
		    throw = throw + dt
			if throw > 60 then
			    throw = 60
			end
		end
		if grabing > 0 then grabing = true else grabing = false end
		light = TransformToParentPoint(TransformToParentTransform(GetBodyTransform(GetToolBody()), GetShapeLocalTransform(Gray_Shape)), Vec(0, 0, 0.1))
        local Lighter_Shapes = GetBodyShapes(GetToolBody())
		local Opening_Shape = Lighter_Shapes[2]
	    local Gray_Shape = Lighter_Shapes[3]
		if InputDown("rmb") and not grabing and opening < 1 and not closing and throw == 60 then
            opening = math.min(opening + dt * 3, 1)
        end
		if opening == 1 and not enabled and try_timer == 0 then
		    try_timer = 0.5
		end
		if InputReleased("rmb") and closing and opening == 0 then
		    closing = false
		end
		if (not InputDown("rmb") and not enabled) or (closing and enabled) then
		    opening = math.max(opening - dt * 3, 0)
			try_timer = 0
			if opening == 0 then
			    if not InputDown("rmb") then closing = false end
				enabled = false
			end
		end
		if InputPressed("rmb") and enabled and not grabing then
		    closing = true
		end
        --opening = math.max(opening - dt * 3, 0)*
		SetShapeLocalTransform(Opening_Shape, Transform(Vec(0.25, -0.25, -0.5), QuatEuler(-90 + opening*135, 0, 0)))
		SetShapeLocalTransform(Gray_Shape, Transform(Vec(0.275, -0.26, -0.525), QuatEuler(-90, 0, 0)))
		if try_timer > 0 then
		    try_timer = try_timer - dt
			if try_timer <= 0 then
                try_timer = 0
				PlaySound(click_sound, GetPlayerCameraTransform().pos)
			    if math.random() <= 0.3 or firstTry then
				    enabled = true
				else 
				    start_fail_timer = 0.25
				end
			end
		end
		if start_fail_timer > 0 then
		    PointLight(light, 1, 0.7, 0, 0.25*start_fail_timer*4)
			start_fail_timer = start_fail_timer - dt
		end
		if enabled then
		    PointLight(light, 1, 0.3, 0.1, 1.25*opening)
		end
		if enabled and InputDown("lmb") and not grabing then
		    local hit, dis = QueryRaycast(GetPlayerCameraTransform().pos, TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), 2)
			if hit then
			    local hitpos = VecAdd(GetPlayerCameraTransform().pos, VecScale(TransformToParentVec(GetPlayerCameraTransform(), Vec(0, 0, -1)), dis))
				SpawnFire(hitpos)
				local a = TransformToLocalPoint(GetPlayerCameraTransform(), hitpos)
				SetToolTransform(Transform(VecAdd(a, Vec(-0.3, 0.3, 0.5)), QuatEuler(0, 0, 0)), 0)
			else
			    SetToolTransform(Transform(Vec(-0.3, 0.3, -1.5), QuatEuler(0, 0, 0)), 0)
			end
		end
	end
end

function draw()
    if GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0 then
	    if enabled and not(enabled and InputDown("lmb")) and throw == 60 then
		    local Lighter_Shapes = GetBodyShapes(GetToolBody())
	        local Gray_Shape = Lighter_Shapes[3]
		    light = TransformToParentPoint(TransformToParentTransform(GetBodyTransform(GetToolBody()), GetShapeLocalTransform(Gray_Shape)), Vec(0, 0, 0.1))
		    local pos = light
			local x, y, dis = UiWorldToPixel(pos)
			UiTranslate(x, y-(1-opening)*10)
			UiScale(math.max((opening-0.5)*2, 0)*0.7)
			UiAlign("center middle")
			UiImage("MOD/img/Flame.png")
		end
	end
end